#! /usr/bin/python3
#
#################################################################
## Copyright (c) 2013 Norbert S. <junky-zs@gmx.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
#################################################################
# Ver:0.0.5  / Datum 03.08.2017
#################################################################
#
import sys, time
import argparse
sys.path.append('./../lib')
import ht_trx_if


global transceiver_if

def  set_betriebsart_netcom_mode(betriebsart):
     betriebswert=0
     if betriebsart in ['auto','heizen','sparen','frost'] or betriebsart in ['a','h','s','f']:
          if   betriebsart in ['auto','a']:
               betriebswert=4
          elif betriebsart in ['heizen','h']:
               betriebswert=3
          elif betriebsart in ['sparen','s']:
               betriebswert=2
          elif betriebsart in ['frost','f']:
               betriebswert=1
          else:
               return
               
          # 1. send to master (netcom100 bytes)
          to_master    = [0x10,0xff,0x0e,0x00,0x65,betriebswert]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_master)
          time.sleep(1.0)

          # 2. send to master (netcom100 bytes)
          to_master    = [0x10,0xff,0x04,0x00,0x79,betriebswert]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_master)
          time.sleep(1.0)

        # 3. send to FB fernbedienung (netcom100 bytes)
          to_fb        = [0x18,0xff,0x0e,0x00,0x65,betriebswert]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_fb)
          time.sleep(1.0)
          
          # 4. send to FB (netcom100 bytes)
          to_fb        = [0x18,0xff,0x04,0x00,0x79,betriebswert]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_fb)
          time.sleep(1.0)
     else:
          print("falsche betriebsart")


def  set_tsoll_netcom_mode(T_soll, betriebsmode):
     global transceiver_if
     mode=betriebsmode.upper()
##     print("T_soll:{0}".format(T_soll))
##     print("mode  :{0}".format(mode))

     tsoll=int(T_soll*2)

     if 'HE' in mode:
          # 1. send to master (netcom100 bytes)
          to_master    = [0x10,0xff,0x11,0x00,0x65,tsoll]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_master)
          time.sleep(1.0)
          
          # 2. send to master (netcom100 bytes)
          to_master    = [0x10,0xff,0x07,0x00,0x79,tsoll]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_master)
          time.sleep(1.0)

          # 3. send to FB fernbedienung (netcom100 bytes)
          to_fb        = [0x18,0xff,0x11,0x00,0x65,tsoll]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_fb)
          time.sleep(1.0)
          
          # 4. send to FB (netcom100 bytes)
          to_fb        = [0x18,0xff,0x07,0x00,0x79,tsoll]
          # send data to piduino
          transceiver_if.send_data_2_bus(to_fb)
          time.sleep(1.0)
          
     ######## not active ####################     
          # 5. ask master for data (netcom100 bytes)
          to_master    = [0x90,0xff,0x11,0x01,0x00,0x65]
          # send data to piduino
     #     transceiver_if.send_data_2_bus(to_master)
     #     time.sleep(3.0)

          # 6. ask master for data (netcom100 bytes)
          to_master    = [0x90,0xff,0x07,0x01,0x00,0x79]
          # send data to piduino
     #     transceiver_if.send_data_2_bus(to_master)
     #     time.sleep(3.0)
     
     elif 'SP' in mode:
          print("mode:'{0}' not implemented".format(betriebsmode))
     elif 'FR' in mode:
          print("mode:'{0}' not implemented".format(betriebsmode))
     else:
          print("unknown mode:'{0}'".format(betriebsmode))


def  setmode_ht_transceiver(option):
     global transceiver_if
     try:
          if option == 240:
               # reset board, no response
               transceiver_if.send_data_2_transceiver('M', option, False)
          else:          
               transceiver_if.send_data_2_transceiver('M', option)
     except ValueError as e:
          print("wrong config-parameter:{0}".format(e))

def  setconfig_ht_transceiver(data):
     global transceiver_if
     try:
          option  =int(data[0])
          databyte=int(data[1])
          if(option == 1):
               if(databyte in [0,1,2,3]):
                    if(databyte==0):
                         print("# setconfig; Mode:0 -> OFF, no Tx and Rx")
                    if(databyte==1):
                         print("# setconfig; Mode:1 -> No TX, RX with header")
                    if(databyte==2):
                         print("# setconfig; Mode:2 -> TX, RX in RAW-format")
                    if(databyte==3):
                         print("# setconfig; Mode:3 -> TX, RX with header")
                    
                    transceiver_if.send_data_2_transceiver('C', option, True, [databyte])
                    print("  -> ht_transceiver 'reboot' is required <-")
               else:
                    print("wrong config-parameter2 (0,1,2 or 3 are valid)")
          elif(option == 2):
               if ((databyte >= 0x0a) and (databyte < 0x80)):
                    print("# setconfig; Device-Adress:{0:02x}".format(databyte))
                    print("  !!! Attention: use the right and unused device-address !!!")
                    print("  !!!   bus-errors and collisions can occur !!!")
                    transceiver_if.send_data_2_transceiver('C', option, True, [databyte])
                    print("  -> ht_transceiver 'reboot' is required <-")
               else:
                    print("wrong config-parameter2 (>9 and <128)")
          else:
                    print("wrong config-parameter1 (1 or 2 are valid)")
     except ValueError as e:
          print("wrong config-parameter:{0}".format(e))
          

def  getconfig_ht_transceiver(option):
     global transceiver_if
     try:
          ioption  =int(option[0])
          data_out=[]
          if (ioption in [1,2]):
               transceiver_if.receive_data_from_transceiver('C', ioption, data_out)
               if ioption==1:
                    print("Startmode    :({0})d".format(data_out[0]))
               elif ioption==2:
                    print("Clientaddress:({0})d".format(data_out[0]))
          else:
               print("wrong config-parameter (must be:1 or 2)")
     except ValueError as e:
          print("wrong config-parameter:{0}".format(e))


def setscript_options():
     global arguments
     arguments={}
     parser = argparse.ArgumentParser(description='Setup heater-temperatur/-mode and transceiver-configuration;Rev:0.2')
     parser.add_argument('-t','--t', default=10.0, type=float,
                   help='Gewuenschte Temperatur     (default: 10.0 Grad)')
     parser.add_argument('-m','--m', default='heizen', type=str,
                   help='Betriebsmode f. Temperatur (default: heizen) Parameter:heizen/sparen/frost')
     parser.add_argument('-b','--b', default='none', type=str,
                   help='Betriebsart der Heizung    (default:keine Aktion) Parameter:auto/heizen/sparen/frost')
     parser.add_argument('-TRXm', default=0xff, type=int,
                   help='Setup ht_transceiver-mode  (default:keine Aktion) Parameter:0 | 1')
#     parser.add_argument('-TRXc', nargs='*', default=[0xff,0], type=int,
     parser.add_argument('-TRXc', nargs='*', default=[0xff,0],
                   help='Write/Read ht_transceiver config  (default:keine Aktion) Parameter1:1 | 2,  Parameter2:0/1/2/3 | device-address | ?')
     
     arguments = vars(parser.parse_args())
     
                     
def main():
     global transceiver_if
     ##### activate the valid devicename for the piduino-Port
     #
     # deviceport="/dev/ttyAMA0"
     deviceport="/dev/ttyUSB0"
     # deviceport="/dev/ttyUSB1"
     #####
     try:
          transceiver_if=ht_trx_if.cht_trx_if(deviceport)
          transceiver_if.run()
     except:
          print ("could not open deviceport: {0}".format(deviceport))
          quit()
          

     if arguments['t'] != 10.0:
          set_tsoll_netcom_mode(arguments['t'], arguments['m'])

     if arguments['b'] != 'none':
          set_betriebsart_netcom_mode(arguments['b'])
          
     if arguments['TRXm'] != 0xff:
          if arguments['TRXm'] in [0,1,2,3,240]:
               if arguments['TRXm'] == 240:
                    print("Reset of Transceiver Board, no response visible !! ")
               setmode_ht_transceiver(arguments['TRXm'])
          else:
               print(" -> wrong parameter:{0}".format(arguments['TRXm']))

     if arguments['TRXc'] != [0xff,0]:
          if(len(arguments['TRXc']) == 2):
               if (arguments['TRXc'][1] =='?'):
                    getconfig_ht_transceiver(arguments['TRXc'])
               else:                    
                    setconfig_ht_transceiver(arguments['TRXc'])
          else:
               print("-TRXc: Falsche Anzahl Parameter (2), P1:1->mode|2->Device-address; P2:mode-value|address-value|?")

     time.sleep(1)


setscript_options()
main()

